
--Copyright (c) 1993 Ohio Board of Regents and the University of
--Cincinnati.  All Rights Reserved.


-- An example in the construction of petri nets using the vhdl design
-- entities and package of in this directory.  This example
-- instantiates Dijkstra's classic Dining Philosophers Problem [1968]. 

library petri;
use petri.petri.all;
entity petri_use is

end;


architecture demo of petri_use is

signal arc1, arc2, arc3, arc4, arc5, 
       arc6, arc7, arc8, arc9, arc10,
       arc11, arc12, arc13, arc14, arc15,
       arc16, arc17, arc18, arc19, arc20,
       arc21, arc22, arc23, arc24, arc25,
       arc26, arc27, arc28, arc29, arc30,
       arc31, arc32, arc33, arc34, arc35,
       arc36, arc37, arc38, arc39, arc40 : arc bus; 

component place_1_1

    generic (initial_marking : integer;
             place_name      : string;
             debug_cntrl     : debug := trace_tokens);

    port (in_arc1, out_arc1 : inout arc bus );

end component;
       
component place_2_2

    generic (initial_marking : integer;
             place_name      : string;
             debug_cntrl     : debug := trace_tokens);

    port (in_arc1, in_arc2, out_arc1, out_arc2 : inout arc bus );

end component;

component transition_1_3

    generic (transition_name : string;
             debug_cntrl     : debug := firing);

    port (in_arc1                      : inout arc bus;
          out_arc1, out_arc2, out_arc3 : inout arc bus);

end component;

component transition_3_1

    generic (transition_name : string;
             debug_cntrl     : debug := firing);

    port (in_arc1,  in_arc2,  in_arc3  : inout arc bus;
          out_arc1                     : inout arc bus);

end component;


for P1, P2, P3, P4, P5      : place_1_1 use entity work.place_1_1(structure);
for P6, P7, P8, P9, P10     : place_1_1 use entity work.place_1_1(structure);
for P11, P12, P13, P14, P15 : place_2_2 use entity work.place_2_2(structure);

for T1, T3, T5, T7, T9  : transition_3_1 use entity work.transition_3_1(structure);
for T2, T4, T6, T8, T10 : transition_1_3 use entity work.transition_1_3(structure);


begin

P1 : place_1_1 
     generic map (0, "M1")
     port map (arc4, arc1);
P2 : place_1_1
     generic map (1, "M2")
     port map (arc10, arc7);
P3 : place_1_1 
     generic map (1, "M3")
     port map (arc18, arc15);
P4 : place_1_1
     generic map (1, "M4")
     port map (arc26, arc23);
P5 : place_1_1 
     generic map (1, "M5")
     port map (arc34, arc31);
P6 : place_1_1
     generic map (1, "E1")
     port map (arc2, arc3);
P7 : place_1_1 
     generic map (0, "E2")
     port map (arc8, arc9);
P8 : place_1_1
     generic map (0, "E3")
     port map (arc16, arc17);
P9 : place_1_1 
     generic map (0, "E4")
     port map (arc24, arc25);
P10: place_1_1
     generic map (0, "E5")
     port map (arc32, arc33);
P11: place_2_2 
     generic map (0, "C1")
     port map (arc5, arc12, arc13, arc14);
P12: place_2_2
     generic map (1, "C2")
     port map (arc11, arc20, arc21, arc22);
P13: place_2_2 
     generic map (1, "C3")
     port map (arc19, arc28, arc29, arc30);
P14: place_2_2
     generic map (1, "C4")
     port map (arc27, arc35, arc37, arc38);
P15: place_2_2
     generic map (0, "C5")
     port map (arc6, arc36, arc39, arc40);       
T1 : transition_3_1
     generic map ("T1")
     port map (arc1, arc14, arc40, arc2);
T2 : transition_1_3
     generic map ("T2")
     port map (arc3, arc4, arc5, arc6);
T3 : transition_3_1
     generic map ("T3")
     port map (arc7, arc13, arc22, arc8);
T4 : transition_1_3
     generic map ("T4")
     port map (arc9, arc10, arc11, arc12);
T5 : transition_3_1
     generic map ("T5")
     port map (arc15, arc21, arc29, arc16);
T6 : transition_1_3
     generic map ("T6")
     port map (arc17, arc18, arc19, arc20);
T7 : transition_3_1
     generic map ("T7")
     port map (arc23, arc30, arc38, arc24);
T8 : transition_1_3
     generic map ("T8")
     port map (arc25, arc26, arc27, arc28);       
T9 : transition_3_1
     generic map ("T9")
     port map (arc31, arc37, arc39, arc32);
T10: transition_1_3
     generic map ("T10")
     port map (arc33, arc34, arc35, arc36);       

end;
