
--Copyright (c) 1993 Ohio Board of Regents and the University of
--Cincinnati.  All Rights Reserved.


-- An example in the construction of petri nets using the vhdl design
-- entities and package of in this directory.  This example
-- instantiates the scheduling queues of a simple operating system.
-- Refer to thesis for details.

library petri;
use petri.petri.all;

entity os is
end os;

architecture structural of os is
  component place_1_1 
	generic(initial_marking : integer;
		place_name      : string;
		debug_cntrl     : debug := trace_tokens);
	port(out_arc1: inout arc bus;
    	     in_arc1: inout arc bus);
  end component;
  component transition_1_1 
	generic(transition_name : string;
	 	debug_cntrl     : debug := firing);

	port(in_arc1: inout arc bus;
             out_arc1: inout arc bus);
  end component;
  component place_3_2 
	generic(initial_marking : integer;
		place_name      : string;
		debug_cntrl     : debug := trace_tokens);

	port(out_arc2: inout arc bus;
             out_arc1: inout arc bus;
             in_arc2: inout arc bus;
             in_arc3: inout arc bus;
             in_arc1: inout arc bus);
  end component;
  component transition_2_1 
	generic(transition_name : string;
	 	debug_cntrl     : debug := firing);

	port(in_arc2: inout arc bus;
             in_arc1: inout arc bus;
             out_arc1: inout arc bus);
  end component;
  component place_1_3 
	generic(initial_marking : integer;
		place_name      : string;
		debug_cntrl     : debug := trace_tokens);

	port(out_arc3: inout arc bus;
             out_arc2: inout arc bus;
             out_arc1: inout arc bus;
             in_arc1: inout arc bus);
  end component;
  component transition_1_2 
	generic(transition_name : string;
	 	debug_cntrl     : debug := firing);

	port(out_arc1: inout arc bus;
             out_arc2: inout arc bus;
             in_arc1: inout arc bus);
  end component;
  component place_3_1 
	generic(initial_marking : integer;
		place_name      : string;
		debug_cntrl     : debug := trace_tokens);

	port(out_arc1: inout arc bus;
             in_arc1: inout arc bus;
             in_arc3: inout arc bus;
             in_arc2: inout arc bus);
  end component;
  component place_1_0 
	generic(initial_marking : integer;
		place_name      : string;
		debug_cntrl     : debug := trace_tokens);

	port(in_arc1: inout arc bus);
  end component;
  for place_1_12: place_1_1 use entity petri.place_1_1(structure);
  for place_1_15: place_1_1 use entity petri.place_1_1(structure);
  for transition_1_18: transition_1_1 use entity petri.transition_1_1(structure);
  for transition_1_111: transition_1_1 use entity petri.transition_1_1(structure);
  for transition_1_114: transition_1_1 use entity petri.transition_1_1(structure);
  for place_3_217: place_3_2 use entity petri.place_3_2(structure);
  for transition_2_123: transition_2_1 use entity petri.transition_2_1(structure);
  for place_1_327: place_1_3 use entity petri.place_1_3(structure);
  for transition_1_232: transition_1_2 use entity petri.transition_1_2(structure);
  for transition_1_236: transition_1_2 use entity petri.transition_1_2(structure);
  for transition_1_240: transition_1_2 use entity petri.transition_1_2(structure);
  for place_3_144: place_3_1 use entity petri.place_3_1(structure);
  for place_1_049: place_1_0 use entity petri.place_1_0(structure);
  signal NONAME53: arc bus;
  signal NONAME56: arc bus;
  signal NONAME59: arc bus;
  signal NONAME62: arc bus;
  signal NONAME65: arc bus;
  signal NONAME68: arc bus;
  signal NONAME71: arc bus;
  signal NONAME74: arc bus;
  signal NONAME77: arc bus;
  signal NONAME80: arc bus;
  signal NONAME83: arc bus;
  signal NONAME86: arc bus;
  signal NONAME89: arc bus;
  signal NONAME92: arc bus;
  signal NONAME95: arc bus;
  signal NONAME98: arc bus;
  signal NONAME101: arc bus;
  signal NONAME104: arc bus;
 
  disconnect all : arc after 0 fs;

begin
  place_1_12:place_1_1 
	generic map(10, "P1")
	port map(NONAME59,NONAME56);
  place_1_15:place_1_1 
	generic map(0, "P2")
	port map(NONAME77,NONAME74);
  transition_1_18:transition_1_1 
	generic map("T1")
	port map(NONAME53,NONAME56);
  transition_1_111:transition_1_1 
	generic map("T2")
	port map(NONAME59,NONAME62);
  transition_1_114:transition_1_1 
	generic map("T3")
	port map(NONAME77,NONAME80);
  place_3_217:place_3_2 
	generic map(0, "P3")
	port map(NONAME65,NONAME53,NONAME62,NONAME80,NONAME104);
  transition_2_123:transition_2_1 
	generic map("T4")
	port map(NONAME65,NONAME101,NONAME68);
  place_1_327:place_1_3 
	generic map(0, "P4")
	port map(NONAME89,NONAME71,NONAME95,NONAME68);
  transition_1_232:transition_1_2 
	generic map("T5")
	port map(NONAME83,NONAME74,NONAME71);
  transition_1_236:transition_1_2 
	generic map("T6")
	port map(NONAME92,NONAME86,NONAME89);
  transition_1_240:transition_1_2 
	generic map("T7")
	port map(NONAME104,NONAME98,NONAME95);
  place_3_144:place_3_1 
	generic map(1, "P5")
	port map(NONAME101,NONAME98,NONAME83,NONAME92);
  place_1_049:place_1_0 
	generic map (0, "P6")
	port map(NONAME86);
end structural;
